/**
  Generated Main Source File

  Company:
    Microchip Technology Inc.

  File Name:
    main.c

  Summary:
    This is the main file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.77
        Device            :  PIC16F18857
        Driver Version    :  2.00

  I/O - Matrix_LED(LTP-12188M-08): 
    RA0-RA7 - Cathode(Green) 
    RB0-RB7 - Cathode(Red) 
    RC0-RC7 - Anode 
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#include "mcc_generated_files/mcc.h"

// EEPROM
__EEPROM_DATA(0x00,0xFE,0x90,0x98,0x94,0x62,0x00,0x00);     // R
__EEPROM_DATA(0x00,0x1C,0x2A,0x2A,0x2A,0x10,0x00,0x00);     // e
__EEPROM_DATA(0x00,0x1C,0x22,0x22,0x12,0xFC,0x00,0x00);     // d
__EEPROM_DATA(0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);     // (uN)
__EEPROM_DATA(0x00,0x7C,0x82,0x92,0x92,0x5E,0x00,0x00);     // G
__EEPROM_DATA(0x00,0x3E,0x10,0x20,0x20,0x10,0x00,0x00);     // r    
__EEPROM_DATA(0x00,0x1C,0x2A,0x2A,0x2A,0x10,0x00,0x00);     // e
__EEPROM_DATA(0x00,0x1C,0x2A,0x2A,0x2A,0x10,0x00,0x00);     // e
__EEPROM_DATA(0x00,0x3E,0x10,0x20,0x20,0x1E,0x00,0x00);     // n
__EEPROM_DATA(0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);     // (uN)
__EEPROM_DATA(0x00,0x7C,0x82,0x82,0x82,0x7C,0x00,0x00);     // O
__EEPROM_DATA(0x00,0x3E,0x10,0x20,0x20,0x10,0x00,0x00);     // r
__EEPROM_DATA(0x00,0x04,0x2A,0x2A,0x2A,0x1C,0x00,0x00);     // a
__EEPROM_DATA(0x00,0x3E,0x10,0x20,0x20,0x1E,0x00,0x00);     // n
__EEPROM_DATA(0x00,0x18,0x25,0x25,0x25,0x3E,0x00,0x00);     // g
__EEPROM_DATA(0x00,0x1C,0x2A,0x2A,0x2A,0x10,0x00,0x00);     // e
__EEPROM_DATA(0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);     // (uN)
__EEPROM_DATA(0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00);

// O[oϐ錾
unsigned int Table[8];      // \pobt@
unsigned long Adrs;     // AhXϐ
unsigned long StartAdrs;    // f[^ǂݏoJnAhX 
unsigned long EndAdrs;     // f[^ǂݏoIAhX

unsigned long RedStart = 0;     // ԐF\JnAhX
unsigned long RedEnd = 32;      // ԐF\IAhX
unsigned long GreenStart = 33;   // ΐF\JnAhX       
unsigned long GreenEnd = 80;     // ΐF\IAhX

unsigned int i,j;     // \pϐ

// vg^Cv錾
void Disp();    // \֐
void Shift();    // Vtg֐

/*
                         Main application
 */
void main(void)
{
    // initialize the device
    SYSTEM_Initialize();

    // When using interrupts, you need to set the Global and Peripheral Interrupt Enable bits
    // Use the following macros to:

    // Enable the Global Interrupts
    //INTERRUPT_GlobalInterruptEnable();

    // Enable the Peripheral Interrupts
    //INTERRUPT_PeripheralInterruptEnable();

    // Disable the Global Interrupts
    //INTERRUPT_GlobalInterruptDisable();

    // Disable the Peripheral Interrupts
    //INTERRUPT_PeripheralInterruptDisable();

    while (1)
    {
        // Add your application code

        StartAdrs = 0;      // f[^ǂݏoJnAhXw
        EndAdrs = 136;      // f[^ǂݏoIAhXw        

        Shift();     // Vtg֐Ăяo
    }
}

void Shift()     // Vtg֐
{
    while (1)
    {
        Adrs = StartAdrs;   // Adrsϐ
        
        for(i=0; i<8; i++) {

            Table[i] = eeprom_read(Adrs);   // \pobt@EEPROMwAhX̃f[^i[            
            Adrs++;     // AdrsCNg
            if (Adrs > EndAdrs)     // Adrs > EndAdrsȂAdrsZbg        
                Adrs = 0;
        }            

        Disp();     // \֐Ăяo        
        
        StartAdrs++;    // StartAdrsCNg
        if (StartAdrs > EndAdrs)    //StartAdrs > EndAdrsaȂ烋[v𔲂 
            break;    
    }
}

void Disp()     // \֐
{
    for(j=0; j<15; j++) {       // XN[x        

        for(i=0; i<8; i++) {

// ԐF\            
            if((Adrs >= RedStart) && (Adrs <= RedEnd))  {
                LATA = 0xFF;    // J\[h(Green)SHi()
                LATB = ~(Table[i]); // \pobt@̃f[^J\[h(Red)Ƀrbg]RA|[gɏo
            }

// ΐF\            
            else if((Adrs >= GreenStart) && (Adrs <= GreenEnd)) {
                LATA = ~(Table[i]); // \pobt@̃f[^J\[h(Green)Ƀrbg]RA|[gɏo
                LATB = 0xFF;    // J\[h(Red)SHi()
            }

// F(+)\            
            else    {
                LATA = ~(Table[i]); // \pobt@̃f[^J\[h(Green)Ƀrbg]RA|[gɏo
                LATB = ~(Table[i]); // \pobt@̃f[^J\[h(Red)Ƀrbg]RA|[gɏo
            }

            LATC = 0x01 << i;   // Am[hVtgRC|[gɏo      

            __delay_ms(1);  // _Ci~bN_             
        }            
    }        
}

/**
 End of File
*/